local player = { x = 100, y = 100, r = 0 }
local bullet = { x = 0, y = 0, dx = 0, dy = 0 }
local enemy = { x = 200, y = 200, d = 0 }
local mouse = { x = 0, y = 0 }

function love.init ( )
	math.randomseed ( os.time ( ) )
	enemy.d = math.random ( ) * math.pi * 2
end

function love.draw ( ) 
	love.graphics.push ( )
	love.graphics.translate ( player.x, player.y )
	love.graphics.rotate ( -player.r )
	love.graphics.line ( 10, 0, -3, -3, -3, 3, 10, 0 )
	love.graphics.pop ( )
	love.graphics.circle ( "line", enemy.x, enemy.y, 5, 6 )
	love.graphics.line ( bullet.x, bullet.y, bullet.x + bullet.dx / 10, bullet.y + bullet.dy / 10 )
end

function love.update ( delta )
	if love.keyboard.isDown ( "down" ) then player.y = ( player.y + 100 * delta ) % 600
	elseif love.keyboard.isDown ( "up" ) then player.y = ( player.y - 100 * delta ) % 600 end
	if love.keyboard.isDown ( "left" ) then player.x = ( player.x - 100 * delta ) % 800
	elseif love.keyboard.isDown ( "right" ) then player.x = ( player.x + 100 * delta ) % 800 end
	
	enemy.x = ( enemy.x + math.cos ( enemy.d ) * 50 * delta ) % 800
	enemy.y = ( enemy.y - math.sin ( enemy.d ) * 50 * delta ) % 600
	
	if math.random ( ) < delta * 3 then
		enemy.d = enemy.d + math.random ( -1, 1 ) * 0.2
	end
	
	bullet.x = ( bullet.x + bullet.dx * delta ) % 800
	bullet.y = ( bullet.y + bullet.dy * delta ) % 600
	
	if bullet.x > enemy.x - 10 and bullet.x < enemy.x + 10 and bullet.y > enemy.y - 10 and bullet.y < enemy.y + 10 then
		enemy.x = math.random ( ) * 800
		enemy.y = math.random ( ) * 600
		bullet.x = 0
		bullet.y = 0
		bullet.dx = 0
		bullet.dy = 0
	end
	
	mouse.x, mouse.y = love.mouse.getPosition ( )
	player.r = -math.atan2 ( mouse.y - player.y, mouse.x - player.x )
end

function love.keypressed ( keycode, unicode ) 
	if keycode == "escape" then
		love.event.push ( "quit" )
	end
end

function love.mousepressed ( x, y, button )
	bullet.x = player.x
	bullet.y = player.y
	player.r = -math.atan2 ( y - player.y, x - player.x ) -- recompute, to "improve accuracy"
	bullet.dx = math.cos ( player.r ) * 400
	bullet.dy = -math.sin ( player.r ) * 400
end

function love.quit ( )
end

function love.run ( )
-- based on löve2d 0.8.0 main loop code
	local ot, nt = 0, 0
	
	love.init ( )
	
	nt = love.timer.getMicroTime ( )
    while true do
		ot = nt
		nt = love.timer.getMicroTime ( )
		love.event.pump ( )
		for e,a,b,c,d in love.event.poll ( ) do
			love.handlers[ e ] ( a, b, c, d )
			if e == "quit" then
				love.quit ( )
				return
			end
		end

		love.update ( nt - ot )
		
		love.graphics.clear ( )
        love.draw ( )
		love.graphics.present ( )
		
        love.timer.sleep ( 0 )		
    end
end